﻿using UnityEngine;
using System.Collections;

public class CollisionCase : MonoBehaviour {

	private enum couleur{BLEU, JAUNE, ROUGE, VERT};
	private bool isActive = false;

	// Use this for initialization
	void Start () {
	
	}

	//appelé par MissionManager pour activer la mission
	public void activeMission1(bool active)
	{
		isActive = active;
	}
	
	void OnTriggerEnter2D(Collider2D col)
	{
		if(isActive == true)
		{
			if (col.gameObject.tag == "Player") 
			{
				couleur couleur_case = getCaseColor(this.gameObject);
				couleur couleur_player = getPlayerColor(col.gameObject);

				if(couleur_case == couleur_player)
				{
					//on vérifie si le joueur possède l'objet
					if (getPlayerAsObject(col.gameObject) == true)
						Debug.Log("Le joueur "+col.gameObject.GetComponentInParent<Transform>().parent.name+" a gagné !!");

					//mettre un écran de fin de partie
					Application.LoadLevel("s2");				
				}
			}
		}
	}

	//récupère la couleur de la case
	private couleur getCaseColor(GameObject element)
	{
		//à continuer
		string case_name = element.name;
		if(case_name.Contains("bleu"))
		   return couleur.BLEU;
	   	else if(case_name.Contains("rouge"))
	        return couleur.ROUGE;
		else if(case_name.Contains("jaune"))
			return couleur.JAUNE;
		else if(case_name.Contains("vert"))
			return couleur.VERT;
		else
			return 0;
	}

	//récupère la couleur du joueur
	private couleur getPlayerColor(GameObject element)
	{
		//à continuer
		string player_name = element.name;
		if(player_name.Contains("0"))
			return couleur.BLEU;
		else if(player_name.Contains("1"))
			return couleur.JAUNE;
		else if(player_name.Contains("2"))
			return couleur.ROUGE;
		else if(player_name.Contains("3"))
			return couleur.VERT;
		else
			return 0;
	}

	//vérifie le le player possède l'objet
	private bool getPlayerAsObject(GameObject element)
	{
		Transform[] children = element.GetComponentsInChildren<Transform>(true);
		foreach (Transform child in children)
		{
			if(child.name == "Background_Sprite")
			{
				if (child.GetComponent<SpriteRenderer>().enabled == true)
					return true;
			}
		}
		return false;
	}
}
