﻿using UnityEngine;
using System.Collections;

public class CollisionObjet : MonoBehaviour {

	GameObject background_player;

	//on supprime l'objet quand un joueur passe dessus
	//et on ajoute un background au joueur
	void OnTriggerEnter2D(Collider2D col)
	{
		if (col.gameObject.tag == "Player") 
		{
			Destroy (this.gameObject);
			//on ajoute le background
			//fonctionne mais cherche dans toute la scène
			//GameObject.Find("winner").GetComponent<SpriteRenderer>().enabled = true;
			//recherche que dans les enfants
			Transform[] children = col.gameObject.GetComponentsInChildren<Transform>(true);
			foreach (Transform child in children)
			{
				if(child.name == "Background_Sprite")
				{
					child.GetComponent<SpriteRenderer>().enabled = true;
					child.transform.parent.parent.GetComponent<PlayerController>().walkSpeed = 5.2f;
				}
			}

			//on indique au MissionManager que l'objet a été récupéré
			Camera.main.GetComponent<MissionManager> ().setPlayer(col.gameObject);
		}
	}
}
