﻿using UnityEngine;
using System.Collections;

public class MapManager : MonoBehaviour {

	public GameObject[,] tilesMap;
	public GameObject[,] elementsMap;

	void Start () {
		tilesMap = GameObject.Find ("Camera").GetComponent<MappingCSV> ().tilesMap;
		elementsMap = GameObject.Find ("Camera").GetComponent<MappingCSV> ().elementsMap;
		DeletePlayer ();
	}

	public void DeletePlayer() {
		for(int l=0; l<elementsMap.GetLength(0); l++)
		{
			for (int c=0; c<elementsMap.GetLength(1); c++)
			{
				if (elementsMap[l,c] != null) {
					if (elementsMap[l,c].name == "Player") {
						elementsMap[l,c] = null;
					}
				}
			}
		}
	}

	public GameObject GetTileInPosition(int ligne, int colonne) {
		if ((tilesMap [ligne, colonne] != null)) {
			return tilesMap [ligne, colonne];
		} else {
			return null;
		}
	}
	
	public void SetTileInPosition(GameObject go, int ligne, int colonne) {
		tilesMap [ligne, colonne] = go;
	}
	
	public int FindTilePositionXWithID(int id) {
		for(int l=0; l<tilesMap.GetLength(0); l++)
		{
			for (int c=0; c<tilesMap.GetLength(1); c++)
			{
				if ((tilesMap[l,c] != null) && (tilesMap[l,c].GetInstanceID() == id)) {
					return c;
				}
			}
		}
		return -1;
	}
	
	public int FindTilePositionYWithID(int id) {
		for(int l=0; l<tilesMap.GetLength(0); l++)
		{
			for (int c=0; c<tilesMap.GetLength(1); c++)
			{
				if ((tilesMap[l,c] != null) && (tilesMap[l,c].GetInstanceID() == id)) {
					return l;
				}
			}
		}
		return -1;
	}
	
	public int FindTilePositionXWithName(string name) {
		for(int l=0; l<tilesMap.GetLength(0); l++)
		{
			for (int c=0; c<tilesMap.GetLength(1); c++)
			{
				if ((tilesMap[l,c] != null) && (tilesMap[l,c].name == name)) {
					return c;
				}
			}
		}
		return -1;
	}
	
	public int FindTilePositionYWithName(string name) {
		for(int l=0; l<tilesMap.GetLength(0); l++)
		{
			for (int c=0; c<tilesMap.GetLength(1); c++)
			{
				if ((tilesMap[l,c] != null) && (tilesMap[l,c].name == name)) {
					return l;
				}
			}
		}
		return -1;
	}
	
	public GameObject GetElementInPosition(int ligne, int colonne) {
		if ((elementsMap [ligne, colonne] != null)) {
			return elementsMap [ligne, colonne];
		} else {
			return null;
		}
	}

	public void SetElementInPosition(GameObject go, int ligne, int colonne) {
		elementsMap [ligne, colonne] = go;
	}

	public int FindElementPositionXWithID(int id) {
		for(int l=0; l<elementsMap.GetLength(0); l++)
		{
			for (int c=0; c<elementsMap.GetLength(1); c++)
			{
				if ((elementsMap[l,c] != null) && (elementsMap[l,c].GetInstanceID() == id)) {
					return c;
				}
			}
		}
		return -1;
	}

	public int FindElementPositionYWithID(int id) {
		for(int l=0; l<elementsMap.GetLength(0); l++)
		{
			for (int c=0; c<elementsMap.GetLength(1); c++)
			{
				if ((elementsMap[l,c] != null) && (elementsMap[l,c].GetInstanceID() == id)) {
					return l;
				}
			}
		}
		return -1;
	}

	public int FindElementPositionXWithName(string name) {
		for(int l=0; l<elementsMap.GetLength(0); l++)
		{
			for (int c=0; c<elementsMap.GetLength(1); c++)
			{
				if ((elementsMap[l,c] != null) && (elementsMap[l,c].name == name)) {
					return c;
				}
			}
		}
		return -1;
	}

	public int FindElementPositionYWithName(string name) {
		for(int l=0; l<elementsMap.GetLength(0); l++)
		{
			for (int c=0; c<elementsMap.GetLength(1); c++)
			{
				if ((elementsMap[l,c] != null) && (elementsMap[l,c].name == name)) {
					return l;
				}
			}
		}
		return -1;
	}

}