﻿using UnityEngine;
using System.Collections;

public class MissionManager : MonoBehaviour {
	//s'occupe de gérer la mission en cours

	public enum couleur{BLEU, JAUNE, ROUGE, VERT};

	//Dictionary<int,>
	public GameObject current_player;
	public int current_mission;
	public couleur current_mission_color;
	public float current_mission_timer;

	//propriété pour savoir si une mission est active ou pas
	public bool isMissionActive {
				get;
				set;
		}

	//propriété pour savoir si l'objet a été ramassé ou pas
	public bool isObjectGet {
				get;
				set;
	}

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	//appelé par le controleur de la manette de xbox
	public void setMission(int number, couleur color)
	{
		//on controle que l'objet a été ramassé
		if(isObjectGet == true && isMissionActive == false)
		{
			current_mission = number;
			current_mission_color = color;
			isMissionActive = true;
			//lancer la mission
			if (current_mission == 1)
			{
				GameObject.Find ("case_"+current_mission_color).GetComponent<CollisionCase> ().activeMission1(true);
			}
			else if (current_mission == 3)
			{
				Debug.Log("MissionManager : " + getIdPlayer(current_mission_color));
				GameObject.Find ("player"+getIdPlayer(current_mission_color)).GetComponent<CollisionPlayers> ().activeMission3(current_player, current_mission_color);
				//GameObject.Find ("player1").transform.FindChild("Player_Sprite").GetComponent<CollisionPlayers> ().activeMission3(current_player, current_mission_color);
			}
		}
	}

	public void setMissionTimer(int number, float time)
	{
		//on controle que l'objet a été ramassé
		if(isObjectGet == true && isMissionActive == false)
		{
			current_mission = number;
			current_mission_timer = time;
			isMissionActive = true;
			//lancer la mission
			if (current_mission == 2)
			{
				current_player.GetComponent<TimeTrigger> ().initialiseTimer(current_player, current_mission_timer);
			}
		}
	}

	//appelé par CollisionObjet quand un player le récupère
	//on attend le maitre du jeu avant de lancer la mission
	public void setPlayer(GameObject player)
	{
		isObjectGet = true;
		current_player = player;
	}

	private int getIdPlayer(couleur color)
	{
		if (color == couleur.BLEU)
			return 0;
		else if (color == couleur.JAUNE)
			return 1;
		else if (color == couleur.ROUGE)
			return 2;
		else if (color == couleur.VERT)
			return 3;
		else
			return 0;
	}
}
