﻿using UnityEngine;
using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;

public class PlayerAnimation : MonoBehaviour {

	public Sprite[] animationIdle;
	public Sprite[] animationMove001;
	public Sprite[] animationMove002;
	public Sprite[] animationMove003;
	public Sprite[] animationMove004;
	public Sprite[] animationMove005;
	public Sprite[] animationMove006;
	public Sprite[] animationMove007;
	public Sprite[] animationMove008;
	const float framesPerSecond = 12.0f;
	private SpriteRenderer spriteRenderer;

	private int dir = 0;
	
	void Start () {
		spriteRenderer = renderer as SpriteRenderer;
	}

	void Update () {
		ChangeDirection ();
		Draw ();
	}

	void Draw () {
		if (this.gameObject.transform.parent.gameObject.name.Contains ("0")) {
			if ((Input.GetAxisRaw ("Horizontal") == 0.0f) && (Input.GetAxisRaw ("Vertical") == 0.0f)) {
				int index = 0;
				switch (dir) {
				case 0:
					index = 0;
					break;
				case 45:
					index = 1;
					break;
				case 90:
					index = 2;
					break;
				case 135:
					index = 3;
					break;
				case 180:
					index = 4;
					break;
				case 225:
					index = 5;
					break;
				case 270:
					index = 6;
					break;
				case 315:
					index = 7;
					break;
				}
				index = index % animationIdle.Length;
				spriteRenderer.sprite = animationIdle [index];
			} else {
				int index = (int)(Time.timeSinceLevelLoad * framesPerSecond);
				switch (dir) {
				case 0:
					index = index % animationMove001.Length;
					spriteRenderer.sprite = animationMove001 [index];
					break;
				case 45:
					index = index % animationMove002.Length;
					spriteRenderer.sprite = animationMove002 [index];
					break;
				case 90:
					index = index % animationMove003.Length;
					spriteRenderer.sprite = animationMove003 [index];
					break;
				case 135:
					index = index % animationMove004.Length;
					spriteRenderer.sprite = animationMove004 [index];
					break;
				case 180:
					index = index % animationMove005.Length;
					spriteRenderer.sprite = animationMove005 [index];
					break;
				case 225:
					index = index % animationMove006.Length;
					spriteRenderer.sprite = animationMove006 [index];
					break;
				case 270:
					index = index % animationMove007.Length;
					spriteRenderer.sprite = animationMove007 [index];
					break;
				case 315:
					index = index % animationMove008.Length;
					spriteRenderer.sprite = animationMove008 [index];
					break;
				}
			}
		}
		else if (this.gameObject.transform.parent.gameObject.name.Contains ("1")) {
			if ((Input.GetAxisRaw ("H") == 0.0f) && (Input.GetAxisRaw ("V") == 0.0f)) {
				int index = 0;
				switch (dir) {
				case 0:
					index = 0;
					break;
				case 45:
					index = 1;
					break;
				case 90:
					index = 2;
					break;
				case 135:
					index = 3;
					break;
				case 180:
					index = 4;
					break;
				case 225:
					index = 5;
					break;
				case 270:
					index = 6;
					break;
				case 315:
					index = 7;
					break;
				}
				index = index % animationIdle.Length;
				spriteRenderer.sprite = animationIdle [index];
			} else {
				int index = (int)(Time.timeSinceLevelLoad * framesPerSecond);
				switch (dir) {
				case 0:
					index = index % animationMove001.Length;
					spriteRenderer.sprite = animationMove001 [index];
					break;
				case 45:
					index = index % animationMove002.Length;
					spriteRenderer.sprite = animationMove002 [index];
					break;
				case 90:
					index = index % animationMove003.Length;
					spriteRenderer.sprite = animationMove003 [index];
					break;
				case 135:
					index = index % animationMove004.Length;
					spriteRenderer.sprite = animationMove004 [index];
					break;
				case 180:
					index = index % animationMove005.Length;
					spriteRenderer.sprite = animationMove005 [index];
					break;
				case 225:
					index = index % animationMove006.Length;
					spriteRenderer.sprite = animationMove006 [index];
					break;
				case 270:
					index = index % animationMove007.Length;
					spriteRenderer.sprite = animationMove007 [index];
					break;
				case 315:
					index = index % animationMove008.Length;
					spriteRenderer.sprite = animationMove008 [index];
					break;
				}
			}
		}
		else if (this.gameObject.transform.parent.gameObject.name.Contains ("2")) {
			if ((Input.GetAxisRaw ("H2") == 0.0f) && (Input.GetAxisRaw ("V2") == 0.0f)) {
				int index = 0;
				switch (dir) {
				case 0:
					index = 0;
					break;
				case 45:
					index = 1;
					break;
				case 90:
					index = 2;
					break;
				case 135:
					index = 3;
					break;
				case 180:
					index = 4;
					break;
				case 225:
					index = 5;
					break;
				case 270:
					index = 6;
					break;
				case 315:
					index = 7;
					break;
				}
				index = index % animationIdle.Length;
				spriteRenderer.sprite = animationIdle [index];
			} else {
				int index = (int)(Time.timeSinceLevelLoad * framesPerSecond);
				switch (dir) {
				case 0:
					index = index % animationMove001.Length;
					spriteRenderer.sprite = animationMove001 [index];
					break;
				case 45:
					index = index % animationMove002.Length;
					spriteRenderer.sprite = animationMove002 [index];
					break;
				case 90:
					index = index % animationMove003.Length;
					spriteRenderer.sprite = animationMove003 [index];
					break;
				case 135:
					index = index % animationMove004.Length;
					spriteRenderer.sprite = animationMove004 [index];
					break;
				case 180:
					index = index % animationMove005.Length;
					spriteRenderer.sprite = animationMove005 [index];
					break;
				case 225:
					index = index % animationMove006.Length;
					spriteRenderer.sprite = animationMove006 [index];
					break;
				case 270:
					index = index % animationMove007.Length;
					spriteRenderer.sprite = animationMove007 [index];
					break;
				case 315:
					index = index % animationMove008.Length;
					spriteRenderer.sprite = animationMove008 [index];
					break;
				}
			}
		}
		else if (this.gameObject.transform.parent.gameObject.name.Contains ("3")) {
			if ((Input.GetAxisRaw ("H3") == 0.0f) && (Input.GetAxisRaw ("V3") == 0.0f)) {
				int index = 0;
				switch (dir) {
				case 0:
					index = 0;
					break;
				case 45:
					index = 1;
					break;
				case 90:
					index = 2;
					break;
				case 135:
					index = 3;
					break;
				case 180:
					index = 4;
					break;
				case 225:
					index = 5;
					break;
				case 270:
					index = 6;
					break;
				case 315:
					index = 7;
					break;
				}
				index = index % animationIdle.Length;
				spriteRenderer.sprite = animationIdle [index];
			} else {
				int index = (int)(Time.timeSinceLevelLoad * framesPerSecond);
				switch (dir) {
				case 0:
					index = index % animationMove001.Length;
					spriteRenderer.sprite = animationMove001 [index];
					break;
				case 45:
					index = index % animationMove002.Length;
					spriteRenderer.sprite = animationMove002 [index];
					break;
				case 90:
					index = index % animationMove003.Length;
					spriteRenderer.sprite = animationMove003 [index];
					break;
				case 135:
					index = index % animationMove004.Length;
					spriteRenderer.sprite = animationMove004 [index];
					break;
				case 180:
					index = index % animationMove005.Length;
					spriteRenderer.sprite = animationMove005 [index];
					break;
				case 225:
					index = index % animationMove006.Length;
					spriteRenderer.sprite = animationMove006 [index];
					break;
				case 270:
					index = index % animationMove007.Length;
					spriteRenderer.sprite = animationMove007 [index];
					break;
				case 315:
					index = index % animationMove008.Length;
					spriteRenderer.sprite = animationMove008 [index];
					break;
				}
			}
		}
	}

	void ChangeDirection() {
		if (this.gameObject.transform.parent.gameObject.name.Contains ("0")) {
			switch (Convert.ToInt32(Input.GetAxisRaw ("Vertical"))) {
			case 0:
				switch (Convert.ToInt32(Input.GetAxisRaw ("Horizontal"))) {
				case -1:
					dir = 270;
					break;
				case 1:
					dir = 90;
					break;
				}
				break;
			case -1:
				switch (Convert.ToInt32(Input.GetAxisRaw ("Horizontal"))) {
				case 0:
					dir = 0;
					break;
				case -1:
					dir = 315;
					break;
				case 1:
					dir = 45;
					break;
				}
				break;
			case 1:
				switch (Convert.ToInt32(Input.GetAxisRaw ("Horizontal"))) {
				case 0:
					dir = 180;
					break;
				case -1:
					dir = 225;
					break;
				case 1:
					dir = 135;
					break;
				}
				break;
			}
		}
		else if (this.gameObject.transform.parent.gameObject.name.Contains ("1")) {
			switch (Convert.ToInt32(Input.GetAxisRaw ("V"))) {
			case 0:
				switch (Convert.ToInt32(Input.GetAxisRaw ("H"))) {
				case -1:
					dir = 270;
					break;
				case 1:
					dir = 90;
					break;
				}
				break;
			case -1:
				switch (Convert.ToInt32(Input.GetAxisRaw ("H"))) {
				case 0:
					dir = 0;
					break;
				case -1:
					dir = 315;
					break;
				case 1:
					dir = 45;
					break;
				}
				break;
			case 1:
				switch (Convert.ToInt32(Input.GetAxisRaw ("H"))) {
				case 0:
					dir = 180;
					break;
				case -1:
					dir = 225;
					break;
				case 1:
					dir = 135;
					break;
				}
				break;
			}
		}
		else if (this.gameObject.transform.parent.gameObject.name.Contains ("2")) {
			switch (Convert.ToInt32(Input.GetAxisRaw ("V2"))) {
			case 0:
				switch (Convert.ToInt32(Input.GetAxisRaw ("H2"))) {
				case -1:
					dir = 270;
					break;
				case 1:
					dir = 90;
					break;
				}
				break;
			case -1:
				switch (Convert.ToInt32(Input.GetAxisRaw ("H2"))) {
				case 0:
					dir = 0;
					break;
				case -1:
					dir = 315;
					break;
				case 1:
					dir = 45;
					break;
				}
				break;
			case 1:
				switch (Convert.ToInt32(Input.GetAxisRaw ("H2"))) {
				case 0:
					dir = 180;
					break;
				case -1:
					dir = 225;
					break;
				case 1:
					dir = 135;
					break;
				}
				break;
			}
		}
		else if (this.gameObject.transform.parent.gameObject.name.Contains ("3")) {
			switch (Convert.ToInt32(Input.GetAxisRaw ("V3"))) {
			case 0:
				switch (Convert.ToInt32(Input.GetAxisRaw ("H3"))) {
				case -1:
					dir = 270;
					break;
				case 1:
					dir = 90;
					break;
				}
				break;
			case -1:
				switch (Convert.ToInt32(Input.GetAxisRaw ("H3"))) {
				case 0:
					dir = 0;
					break;
				case -1:
					dir = 315;
					break;
				case 1:
					dir = 45;
					break;
				}
				break;
			case 1:
				switch (Convert.ToInt32(Input.GetAxisRaw ("H3"))) {
				case 0:
					dir = 180;
					break;
				case -1:
					dir = 225;
					break;
				case 1:
					dir = 135;
					break;
				}
				break;
			}
		}

	}

}