﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class PlayerManager : MonoBehaviour 
{
	private short nombre_player = 0;
	private enum couleur{BLEU, JAUNE, ROUGE, VERT};
	private bool time_flag = false;

	public short Nombre_player() {
		return nombre_player;
	}

	//permet de créer un nouveau player
	//se base sur le nombre de player actuel
	//ordre de création est toujours bleu, jaune, rouge, vert
	public void createNewPlayer()
	{
		if (nombre_player < 4) 
		{
			List<int> coord = transform.GetComponent<MappingCSV> ().generateRandomPosition ();
			GameObject goE = new GameObject ("Player" + nombre_player);
			GameObject child = Instantiate (Resources.Load ("Player 1"), new Vector2 ((0.64f) * coord[1], -(0.64f) * coord[0]), Quaternion.identity) as GameObject;
			child.name = "player" + nombre_player;
			child.transform.parent = goE.transform;
			if(nombre_player == 0) 
			{
				GameObject.Find ("Camera").GetComponent<CameraFollower> ().Target = GameObject.Find ("Player0").transform.FindChild("player0").gameObject;
			}

			//on colore la case de départ/arrivée
			if (nombre_player == 0)
			{
				createInitialPosition(coord, couleur.BLEU);
				//on le colore
				child.GetComponentInChildren<SpriteRenderer> ().color = new Color(0.35f, 0.5f, 0.8f);
			}
			else if (nombre_player == 1)
			{
				createInitialPosition(coord, couleur.JAUNE);
				//on le colore
				child.GetComponentInChildren<SpriteRenderer> ().color = new Color(1.0f, 0.92f, 0.16f);
			}
			else if (nombre_player == 2)
			{
				createInitialPosition(coord, couleur.ROUGE);
				//on le colore
				child.GetComponentInChildren<SpriteRenderer> ().color = new Color(0.9f, 0.23f, 0.23f);
			}
			else if (nombre_player == 3)
			{
				createInitialPosition(coord, couleur.VERT);
				//on le colore
				child.GetComponentInChildren<SpriteRenderer> ().color = new Color(0.23f, 1.0f, 0.32f);
			}

			//on incrémente le compteur
			nombre_player++;
		}
	}

	//supprime un player
	public void deletePlayer()
	{

	}

	private void createInitialPosition(List<int> position, couleur couleur_joueur)
	{
		String case_color = "case_" + couleur_joueur;
		GameObject goE = new GameObject ("Elements");
		GameObject child = Instantiate (Resources.Load (case_color), new Vector2 ((0.64f) * position[1], -(0.64f) * position[0]), Quaternion.identity) as GameObject;
		child.name = case_color;
		child.GetComponent<SpriteRenderer> ().sortingOrder = 1;
		child.transform.parent = goE.transform;
	}

	//le player s'est fait tué, il attend 3s avant de revenir sur la map à une position aléatoire
	//cela ne génère pas une nouvelle case de couleur
	public void playerIsKilled(GameObject player)
	{
		//on désactive le player
		player.SetActive (false);
		//on attend 3s
		/*wait ();
		while (time_flag == false) {}
		time_flag = false;
		//on le bouge*/
		List<int> coord = transform.GetComponent<MappingCSV> ().generateRandomPosition ();
		string cam = searchForCamera (player);
		//GameObject.Find(cam).transform.position = new Vector2 ((0.64f) * coord [1], -(0.64f) * coord [0]);
		player.transform.position = new Vector2 ((0.64f) * coord [1], -(0.64f) * coord [0]);
		GameObject.Find(cam).transform.position = new Vector2 ((0.64f) * coord [1], -(0.64f) * coord [0]);
		//GameObject.Find(cam).GetComponent<CameraFollower> ().updatePosition (coord);
		//on le réactive
		player.SetActive (true);
	}

	//renvoi le nom de la caméra correspondan au nom du player
	private string searchForCamera(GameObject player)
	{
		if(player.transform.parent.name.Contains("0"))
			return "Camera";
		else if (player.transform.parent.name.Contains("1"))
			return "Camera1";
		else if (player.transform.parent.name.Contains("2"))
			return "Camera2";
		else if (player.transform.parent.name.Contains("3"))
			return "Camera3";
		else
			return "";
	}
}